{-# OPTIONS_GHC -XCPP #-}
--------------------------------------------------------------------
-- |
-- Module      : Bamse.Package
-- Description : Description of an MSI package/product.
-- Copyright   : (c) Sigbjorn Finne, 2004-2009
-- License     : BSD3
--
-- Maintainer  : Sigbjorn Finne <sof@forkIO.com>
-- Stability   : provisional
-- Portability : portable
--
-- Main module for an installer creator.
-- 
--------------------------------------------------------------------
module Main ( main ) where

import Bamse.Package
import Bamse.Builder

import PACKAGE as PackageSrc
{-
 This tool currently gets the package specification from
 a Haskell module -- see templates/Base.hs for the signature
 the module is expected to provide.
-}
--import Greencard as PackageSrc
--import HDirectLib as PackageSrc
--import ComPkg as PackageSrc
--import GaloisPkg as PackageSrc
--import Cryptol as PackageSrc
--import Bamse as PackageSrc
--import GHC as PackageSrc
--import Happy as PackageSrc
--import HCDSA as PackageSrc
--import Hugs98 as PackageSrc
--import Hugs98Net as PackageSrc
--import HsDotnet as PackageSrc
--import Base as PackageSrc

main :: IO ()
main = genBuilder pkg_data

-- first class modules, old skool.
pkg_data :: PackageData
pkg_data = defPackageData 
  { p_fileMap              = PackageSrc.dirTree
  , p_distFileMap          = PackageSrc.distFileMap
  , p_defOutFile           = PackageSrc.defaultOutFile
  , p_pkgInfo              = PackageSrc.pkg
  , p_webSite      	   = PackageSrc.webSite
  , p_bannerBitmap 	   = PackageSrc.bannerBitmap
  , p_bgroundBitmap 	   = PackageSrc.bgroundBitmap
  , p_registry     	   = PackageSrc.registry
  , p_baseFeature          = PackageSrc.baseFeature
  , p_features     	   = PackageSrc.features
  , p_featureMap           = PackageSrc.featureMap
  , p_startMenu    	   = PackageSrc.startMenu
  , p_desktopShortcuts     = PackageSrc.desktopShortcuts
  , p_extensions           = PackageSrc.extensions
  , p_verbs                = PackageSrc.verbs
  , p_license              = PackageSrc.license
  , p_userRegistration     = PackageSrc.userRegistration
  , p_defaultInstallFolder = PackageSrc.defaultInstallFolder
  , p_userInstall          = PackageSrc.userInstall
  , p_finalMessage         = PackageSrc.finalMessage
  , p_notForAll            = PackageSrc.userInstall
  , p_services             = PackageSrc.services
--  , p_ghcPackage           = PackageSrc.ghcPackageInfo
  , p_cabalPackage         = PackageSrc.cabalPackageInfo
  , p_nestedInstalls       = PackageSrc.nestedInstalls
  , p_assemblies           = PackageSrc.assemblies
  }

